Attribute VB_Name = "modClock"
Option Explicit

' ---=== Const ===---
Private Const S_OK As Long = &H0&
Private Const NO_ERROR As Long = &H0&
Private Const API_True As Long = &H1&
Private Const API_False As Long = &H0&
Private Const HTCAPTION As Long = &H2&
Private Const CC_STDCALL As Long = &H4&
Private Const IID_Release As Long = &H8&
Private Const GdiPlusVersion As Long = &H1&
Private Const GMEM_MOVEABLE As Long = &H2&
Private Const WM_NCLBUTTONDOWN As Long = &HA1&

Private Const IID_IPicture As String = "{7BF80981-BF32-101A-8BBB-00AA00300CAB}"

Private Enum MatrixOrder
    MatrixOrderPrepend = &H0&
    MatrixOrderAppend = &H1&
End Enum

Public Enum Status
    OK = 0
    GenericError = 1
    InvalidParameter = 2
    OutOfMemory = 3
    ObjectBusy = 4
    InsufficientBuffer = 5
    NotImplemented = 6
    Win32Error = 7
    WrongState = 8
    Aborted = 9
    FileNotFound = 10
    ValueOverflow = 11
    AccessDenied = 12
    UnknownImageFormat = 13
    FontFamilyNotFound = 14
    FontStyleNotFound = 15
    NotTrueTypeFont = 16
    UnsupportedGdiplusVersion = 17
    GdiplusNotInitialized = 18
    PropertyNotFound = 19
    PropertyNotSupported = 20
    ProfileNotFound = 21
End Enum

Private Enum PixelFormats
    PixelFormatUndefined = &H0&
    PixelFormatMax = &HF&
    PixelFormat1_8 = &H100&
    PixelFormat4_8 = &H400&
    PixelFormat8_8 = &H800&
    PixelFormat16_8 = &H1000&
    PixelFormat24_8 = &H1800&
    PixelFormat32_8 = &H2000&
    PixelFormat48_8 = &H3000&
    PixelFormat64_8 = &H4000&
    PixelFormat16bppRGB555 = &H21005
    PixelFormat16bppRGB565 = &H21006
    PixelFormat16bppGrayScale = &H101004
    PixelFormat16bppARGB1555 = &H61007
    PixelFormat24bppRGB = &H21808
    PixelFormat32bppRGB = &H22009
    PixelFormat32bppARGB = &H26200A
    PixelFormat32bppPARGB = &HD200B
    PixelFormat48bppRGB = &H10300C
    PixelFormat64bppARGB = &H34400D
    PixelFormat64bppPARGB = &H1C400E
    PixelFormatGDI = &H20000
    PixelFormat1bppIndexed = &H30101
    PixelFormat4bppIndexed = &H30402
    PixelFormat8bppIndexed = &H30803
    PixelFormatAlpha = &H40000
    PixelFormatIndexed = &H10000
    PixelFormatPAlpha = &H80000
    PixelFormatExtended = &H100000
    PixelFormatCanonical = &H200000
End Enum

' ---=== Types ===---
Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type PictDesc
    cbSizeofStruct As Long
    picType As Long
    hImage As Long
    xExt As Long
    yExt As Long
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Type GDIPlusStartupInput
    GdiPlusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

Private Type GdiplusStartupOutput
    NotificationHook As Long
    NotificationUnhook As Long
End Type

' ----==== Gdi32.dll Deklarationen ====----
Private Declare Function CreateEllipticRgn Lib "Gdi32.dll" ( _
                         ByVal X1 As Long, _
                         ByVal Y1 As Long, _
                         ByVal X2 As Long, _
                         ByVal Y2 As Long) As Long
                         
' ----==== User32.dll Deklarationen ====----
Private Declare Sub ReleaseCapture Lib "User32.dll" ()
                    
Private Declare Sub SendMessage Lib "User32.dll" _
                    Alias "SendMessageA" ( _
                    ByVal hwnd As Long, _
                    ByVal wMsg As Long, _
                    ByVal wParam As Long, _
                    ByRef lParam As Any)
                    
Private Declare Function SetWindowRgn Lib "User32.dll" ( _
                         ByVal hwnd As Long, _
                         ByVal hRgn As Long, _
                         ByVal bRedraw As Long) As Long
                         
Private Declare Function GetWindowRect Lib "User32.dll" ( _
                         ByVal hwnd As Long, _
                         ByRef lpRect As RECT) As Long
                         
Private Declare Function MoveWindow Lib "User32.dll" ( _
                         ByVal hwnd As Long, _
                         ByVal X As Long, _
                         ByVal Y As Long, _
                         ByVal nWidth As Long, _
                         ByVal nHeight As Long, _
                         ByVal bRepaint As Long) As Long
                         
' ----==== Kernel32.dll Deklarationen ====----
Private Declare Sub CopyMemory Lib "Kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pTo As Any, _
                    ByRef uFrom As Any, _
                    ByVal lSize As Long)

Private Declare Sub GetLocalTime Lib "Kernel32.dll" ( _
                    ByRef lpSystemTime As SYSTEMTIME)
                    
' ----==== Oleaut32.dll Deklarationen ====----
Private Declare Function OleCreatePictureIndirect Lib "Oleaut32.dll" ( _
                         ByRef lpPictDesc As PictDesc, _
                         ByRef riid As GUID, _
                         ByVal fOwn As Long, _
                         ByRef lplpvObj As Object) As Long
                         
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long
                         
' ----==== Ole32.dll Deklarationen ====----
Private Declare Function IIDFromString Lib "Ole32.dll" ( _
                         ByVal lpsz As Long, _
                         ByRef lpiid As GUID) As Long

' ----==== Shlwapi.dll Deklarationen ====----
Private Declare Function SHCreateMemStream Lib "Shlwapi.dll" ( _
                         ByVal pInit As Long, _
                         ByVal cbInit As Long) As Long

' ----==== GdiPlus.dll Deklarationen ====----
Private Declare Function GdiplusShutdown Lib "GdiPlus.dll" ( _
                         ByVal token As Long) As Status
                         
Private Declare Function GdiplusStartup Lib "GdiPlus.dll" ( _
                         ByRef token As Long, _
                         ByRef lpInput As GDIPlusStartupInput, _
                         ByRef lpOutput As GdiplusStartupOutput) As Status
                         
Private Declare Function GdipCreateHBITMAPFromBitmap Lib "GdiPlus.dll" ( _
                         ByVal bitmap As Long, _
                         ByRef hbmReturn As Long, _
                         ByVal background As Long) As Status
                         
Private Declare Function GdipDisposeImage Lib "GdiPlus.dll" ( _
                         ByVal image As Long) As Status

Private Declare Function GdipCreateBitmapFromScan0 Lib "GdiPlus.dll" ( _
                         ByVal mWidth As Long, _
                         ByVal mHeight As Long, _
                         ByVal mStride As Long, _
                         ByVal mPixelFormat As Long, _
                         ByVal mScan0 As Long, _
                         ByRef mBitmap As Long) As Status
                         
Private Declare Function GdipLoadImageFromStream Lib "GdiPlus.dll" ( _
                         ByVal mStream As Long, _
                         ByRef mImage As Long) As Status
                         
Private Declare Function GdipDrawImageRect Lib "GdiPlus.dll" ( _
                         ByVal mGraphics As Long, _
                         ByVal mImage As Long, _
                         ByVal mX As Single, _
                         ByVal mY As Single, _
                         ByVal mWidth As Single, _
                         ByVal mHeight As Single) As Status
                         
Private Declare Function GdipGetImageDimension Lib "GdiPlus.dll" ( _
                         ByVal image As Long, _
                         ByRef Width As Single, _
                         ByRef Height As Single) As Status
                         
Private Declare Function GdipGetImageGraphicsContext Lib "GdiPlus.dll" ( _
                         ByVal image As Long, _
                         ByRef graphics As Long) As Status
                         
Private Declare Function GdipDeleteGraphics Lib "GdiPlus.dll" ( _
                         ByVal graphics As Long) As Status

Private Declare Function GdipRotateWorldTransform Lib "GdiPlus.dll" ( _
                         ByVal graphics As Long, _
                         ByVal angle As Single, _
                         ByVal order As MatrixOrder) As Status
                         
Private Declare Function GdipTranslateWorldTransform Lib "GdiPlus.dll" ( _
                         ByVal graphics As Long, _
                         ByVal dx As Single, _
                         ByVal dy As Single, _
                         ByVal order As MatrixOrder) As Status
                         
Private Declare Function GdipResetWorldTransform Lib "GdiPlus.dll" ( _
                         ByVal graphics As Long) As Status

' ----==== Variablen ====----
Private m_GdipToken As Long
Private m_hClockWnd As Long
Private m_SecondHand As Long
Private m_MinuteHand As Long
Private m_HourHand As Long
Private m_ClockFace As Long

' Startet GDI+, macht das Fenster rund und ldt alle Bilder aus der Ressource
Public Function InitClock(ByVal hClockWnd As Long) As Boolean

    Dim bolRet As Boolean
    Dim sngWidth As Single
    Dim sngHeight As Single
    Dim tRECT As RECT
    Dim GdipStartupInput As GDIPlusStartupInput
    Dim GdipStartupOutput As GdiplusStartupOutput
    
    bolRet = False
    
    ' Fensterhandle speichern
    m_hClockWnd = hClockWnd
    
    GdipStartupInput.GdiPlusVersion = GdiPlusVersion
    
    ' GDI+ starten
    If GdiplusStartup(m_GdipToken, GdipStartupInput, _
        GdipStartupOutput) = OK Then
        
        ' Ziffenblatt laden
        If LoadImageFromRes("CUSTOM", 101, m_ClockFace) = OK Then
        
            ' Gre des Bitmaps ermitteln
            If GdipGetImageDimension(m_ClockFace, sngWidth, sngHeight) = OK Then
            
                ' Position und Gre des Fensters ermitteln
                If GetWindowRect(hClockWnd, tRECT) = API_True Then
                
                    ' neue Gre fr das Fenster einstellen
                    If MoveWindow(hClockWnd, tRECT.Left, tRECT.Top, CLng(sngWidth) + 1, _
                        CLng(sngHeight) + 1, API_True) = API_True Then
                    
                        ' Fenster rund machen
                        If SetWindowRgn(hClockWnd, CreateEllipticRgn(0, 0, CLng(sngWidth) + 1, _
                            CLng(sngHeight) + 1), API_True) = API_True Then
                        
                            ' Stundenzeiger laden
                            If LoadImageFromRes("CUSTOM", 102, m_HourHand) = OK Then
        
                                ' Minutenzeiger laden
                                If LoadImageFromRes("CUSTOM", 103, m_MinuteHand) = OK Then
        
                                    ' Sekundenzeiger laden
                                    If LoadImageFromRes("CUSTOM", 104, m_SecondHand) = OK Then
                                    
                                        bolRet = True
                                        
                                    End If
        
                                End If
        
                            End If
                        
                        End If
                
                    End If
                    
                End If
            
            End If
        
        End If
    
    End If
        
    InitClock = bolRet
        
End Function

' Lscht alle Bilder und beendet GDI+
Public Sub DestroyClock()

    ' GdipToken vorhanden?
    If m_GdipToken <> 0& Then
    
        ' alle geladene Bilder lschen
    
        ' Bild vom Sekundenzeiger
        If m_SecondHand <> 0& Then
        
            If GdipDisposeImage(m_SecondHand) = OK Then
            
                m_SecondHand = 0&
                
            End If
            
        End If
        
        ' Bild vom Minutenzeiger
        If m_MinuteHand <> 0& Then
        
            If GdipDisposeImage(m_MinuteHand) = OK Then
            
                m_MinuteHand = 0&
                
            End If
            
        End If
        
        ' Bild vom Stundenzeiger
        If m_HourHand <> 0& Then
        
            If GdipDisposeImage(m_HourHand) = OK Then
            
                m_HourHand = 0&
                
            End If
            
        End If
        
        ' Bild vom Ziffernblatt
        If m_ClockFace <> 0& Then
        
            If GdipDisposeImage(m_ClockFace) = OK Then
            
                m_ClockFace = 0&
                
            End If
            
        End If
        
        ' GDI+ beenden
        If GdiplusShutdown(m_GdipToken) = OK Then
        
            m_GdipToken = 0&
            
        End If
        
    End If
    
End Sub

' Ldt ein Bild aus der Ressource
Private Function LoadImageFromRes(ByVal strResType As String, _
    ByVal lngResID As Long, ByRef lngImage As Long) As Status
    
    Dim pIStream As Long
    Dim lngResSize As Long
    Dim lngRetImage As Long
    Dim lngRet As Status
    Dim bytRes() As Byte
    
    ' Bild in ein ByteArray laden
    bytRes = LoadResData(lngResID, strResType)
    
    ' Gre des ByteArray
    lngResSize = UBound(bytRes) + 1
    
    If lngResSize > 0& Then
    
        ' ein IStream aus den Daten im Speicher erstellen
        pIStream = SHCreateMemStream(VarPtr(bytRes(0)), lngResSize)
                    
        ' ein IStream vorhanden
        If pIStream <> 0& Then
                    
            ' vom IStream ein Bitmap
            lngRet = GdipLoadImageFromStream(pIStream, lngRetImage)
            
            If lngRet = OK Then
                                        
                ' neues Bitmap zurckgeben
                lngImage = lngRetImage
                
            End If
            
            ' IStream lschen
            Call Release(pIStream)
                        
        End If
                    
    End If
    
    LoadImageFromRes = lngRet
    
End Function

' Erstellt aus den geladenen Bildern die Uhr
Public Function GetClock() As StdPicture
    
    Dim bolOk As Boolean
    Dim sngWidth As Single
    Dim sngHeight As Single
    Dim sngHour As Single
    Dim sngMinute As Single
    Dim sngSecond As Single
    Dim lngClock As Long
    Dim lngGraphics As Long
    Dim hClock As Long
    Dim tSYSTEMTIME As SYSTEMTIME
    
    bolOk = False
    
    ' sind alle Bilder vorhanden?
    If (m_ClockFace <> 0&) And (m_HourHand <> 0&) And _
        (m_MinuteHand <> 0&) And (m_SecondHand <> 0&) Then
        
        ' LocalTime ermitteln
        Call GetLocalTime(tSYSTEMTIME)
        
        ' Berechnung der Winkel fr die Drehung des Ziffernblattes
        sngHour = 180! + ((CSng(tSYSTEMTIME.wHour) + (CSng(tSYSTEMTIME.wMinute) / 60!)) * 30!)
        sngMinute = 180! + ((CSng(tSYSTEMTIME.wMinute) + (CSng(tSYSTEMTIME.wSecond) / 60!)) * 6!)
        sngSecond = 180! + ((CSng(tSYSTEMTIME.wSecond) + (CSng(tSYSTEMTIME.wMilliseconds) / 1000!)) * 6!)
    
        ' Gre des Ziffernblattes ermitteln
        If GdipGetImageDimension(m_ClockFace, sngWidth, sngHeight) = OK Then
        
            ' neue Bitmap erstellen
            If GdipCreateBitmapFromScan0(CLng(sngWidth), CLng(sngHeight), _
                0&, PixelFormats.PixelFormat32bppARGB, 0&, lngClock) = OK Then
            
                ' Graphics von neuer Bitmap erstellen
                If GdipGetImageGraphicsContext(lngClock, lngGraphics) = OK Then
                
                    ' Ziffernblatt in das neue Bitmap zeichnen
                    If GdipDrawImageRect(lngGraphics, m_ClockFace, 0, 0, _
                        sngWidth, sngHeight) = OK Then
                    
                        bolOk = True
                        
                        If bolOk = True Then
                        
                            bolOk = False
                        
                            ' Rotationspunkt, mitte Ziffernblatt
                            If GdipTranslateWorldTransform(lngGraphics, sngWidth \ 2, _
                                sngHeight \ 2, MatrixOrderAppend) = OK Then
                        
                                ' Ziffernblatt drehen
                                If GdipRotateWorldTransform(lngGraphics, _
                                    sngHour, MatrixOrderPrepend) = OK Then

                                    ' Stundenzeiger zentriert in das neue Bitmap zeichnen
                                    If GdipDrawImageRect(lngGraphics, m_HourHand, sngWidth \ 2, _
                                        sngHeight \ 2, -sngWidth, -sngHeight) = OK Then

                                        ' Drehung rckgangig machen
                                        If GdipResetWorldTransform(lngGraphics) = OK Then

                                            bolOk = True

                                        End If

                                    End If
                                
                                End If

                            End If
                        
                        End If
                        
                        
                        If bolOk = True Then
                        
                            bolOk = False
                        
                            ' Rotationspunkt, mitte Ziffernblatt
                            If GdipTranslateWorldTransform(lngGraphics, sngWidth \ 2, _
                                sngHeight \ 2, MatrixOrderAppend) = OK Then
                        
                                ' Ziffernblatt drehen
                                If GdipRotateWorldTransform(lngGraphics, _
                                    sngMinute, MatrixOrderPrepend) = OK Then

                                    ' Minutenzeiger zentriert in das neue Bitmap zeichnen
                                    If GdipDrawImageRect(lngGraphics, m_MinuteHand, sngWidth \ 2, _
                                        sngHeight \ 2, -sngWidth, -sngHeight) = OK Then

                                        ' Drehung rckgangig machen
                                        If GdipResetWorldTransform(lngGraphics) = OK Then

                                            bolOk = True

                                        End If

                                    End If
                                
                                End If

                            End If
                            
                        End If
                        
                        
                        If bolOk = True Then
                        
                            bolOk = False
                        
                            ' Rotationspunkt, mitte Ziffernblatt
                            If GdipTranslateWorldTransform(lngGraphics, sngWidth \ 2, _
                                sngHeight \ 2, MatrixOrderAppend) = OK Then
                        
                                ' Ziffernblatt drehen
                                If GdipRotateWorldTransform(lngGraphics, _
                                    sngSecond, MatrixOrderPrepend) = OK Then

                                    ' Sekundenzeiger zentriert in das neue Bitmap zeichnen
                                    If GdipDrawImageRect(lngGraphics, m_SecondHand, sngWidth \ 2, _
                                        sngHeight \ 2, -sngWidth, -sngHeight) = OK Then

                                        ' Drehung rckgangig machen
                                        If GdipResetWorldTransform(lngGraphics) = OK Then

                                            bolOk = True

                                        End If

                                    End If
                                
                                End If

                            End If
                            
                        End If
                    
                    End If
                    
                    ' Graphics lschen
                    Call GdipDeleteGraphics(lngGraphics)
                    
                    If bolOk = True Then
                                                    
                        ' GDI32-Bitmaphandle von neuer Bitmap holen
                        If GdipCreateHBITMAPFromBitmap(lngClock, hClock, &H0) = OK Then
                    
                            ' StdPicture aus dem GDI32-Bitmaphandle erstellen
                            Set GetClock = HandleToPicture(hClock)
        
                        End If
                                                    
                    End If
                    
                End If
                
                ' neue Bitmap lschen
                Call GdipDisposeImage(lngClock)
                
            End If
        
        End If
    
    End If

End Function

' StdPicture aus dem GDI32-Bitmaphandle erstellen
Private Function HandleToPicture(ByVal hBitmap As Long) As IPicture

    Dim tIID As GUID
    Dim tPictDesc As PictDesc
    Dim objPicture As IPicture
    
    ' IID -> GUID
    If IIDFromString(StrPtr(IID_IPicture), tIID) = S_OK Then
    
        ' Parameter festlegen
        With tPictDesc
            .cbSizeofStruct = Len(tPictDesc)
            .picType = vbPicTypeBitmap
            .hImage = hBitmap
        End With
        
        ' IPicture erstellen
        If OleCreatePictureIndirect(tPictDesc, _
            tIID, API_True, objPicture) = S_OK Then
            
            ' IPicture zurckgeben
            Set HandleToPicture = objPicture
            
        End If
        
    End If
    
End Function

Private Sub Release(ByRef pInterface As Long)

    Dim varRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, varRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' Fenster verschieben
Public Sub MoveMyWindow()

    If m_hClockWnd <> 0& Then

        Call ReleaseCapture
    
        Call SendMessage(m_hClockWnd, _
            WM_NCLBUTTONDOWN, HTCAPTION, 0&)
        
    End If
    
End Sub
